function [ys,flag,err,M_]=GB_No_MaP_steadystate(y_,varargin);
% See file mickgia_steady_state_calculations.tex

flag=0;
err=0;
ys=0;
param_GB;
% if isempty(varargin)
M_=evalin('base','M_');
% else
%     M_=varargin{1};
% end
GB_steady_state_stuff;
Ae_cor=Ae;
Ac_cor=Ac;
xie_cor=xie;
xic_cor=xic;
Kc_ss=log(Kc);
auxepsi=1;

AD=exp(0);
Tx_e_ss=Tx_e;
Tx_c_ss=Tx_c;
Cc_obs=1;
Ce_obs=1;
He_obs=1;
Hc_obs=1;
RER_obs=1;
Qe_obs=1;
Qc_obs=1;
Ke_obs=1;
Kc_obs=1;
Ie_obs=1;
Ic_obs=1;
R_b_obs=1;

R_c_obs=1;
R_e_obs=1;
Ne_obs=1;

Nc_obs=1;

Pe_obs=1;
Pc_obs=1;
Rke_obs=1;
Rkc_obs=1;
Ve_obs=1;

Ae_obs=1;
Ac_obs=1;
xie_obs=1;
xic_obs=1;

Ye_obs=1;

Yc_obs=1;

Leverage_e_obs=1;
Leverage_c_obs=1;
spread_e_obs=1;
spread_c_obs=1;

tau_k_c_obs=1;
tau_k_e_obs=1;

Cc_ss=log(Cc);
Ce_ss=log(Ce);
Hc_ss=log(Hc);
He_ss=log(He);
Ic_ss=log(Ic);
Ie_ss=log(Ie);
Se_ss=log(Se);
Sc_ss=log(Sc);
Ke_ss=log(Ke);
Leverage_c_ss=log(Leverage_c);
Leverage_e_ss=log(Leverage_e);
Nc_ss=log(Nc);
Ne_ss=log(Ne);

Ve_ss=log(Ve);
spread_c_ss=log(spread_c);
spread_e_ss=log(spread_e);

tau_k_c_ss=tau_k_c;
tau_k_e_ss=tau_k_e;
Qe_ss=0;
Qc_ss=0;
R_c_ss=log(R_c);
Nc_ss=log(Nc);
Kc_ss=log(Kc);
spread_c_ss=log(spread_c);
% keyboard
% for jj=1:size(M_.param_names,1);
%     %     [xx]=regexp(M_.param_names(jj,:),'\_ss\>');
%     %     if ~isempty(xx)
%     try
%         M_.params(jj,:)=eval([M_.param_names(jj,:),';']);
%     catch
%         error(sprintf('Missing value of parameter %s\n:',M_.param_names(jj,:)))
%         
%     end
%     %     end
% end
% [M_.param_names,num2str(M_.params)]
% assignin('base','M_',M_);
lgy_=M_.endo_names;
% assignin('base','lgy_',M_.endo_names);



Be=exp(Be);
Util=exp(Util);
Util_no_pen=exp(Util_no_pen);
UE=exp(UE);
UC=exp(UC);
NFA_E=exp(NFA_E);
tau_k_c=exp(tau_k_c);
tau_k_e=exp(tau_k_e);
tau_l_e=exp(tau_l_e);
tau_l_c=exp(tau_l_c);
tax_pen_e=exp(tax_pen_e);
tax_pen_c=exp(tax_pen_c);
UE_no_pen=exp(UE_no_pen);	
UC_no_pen=exp(UC_no_pen);
Delta_tau_k_c=exp(Delta_tau_k_c);
Delta_tau_k_e=exp(Delta_tau_k_e);
Ge=exp(Ge);
Gc=exp(Gc);
Tx_e=exp(Tx_e);
Tx_c=exp(Tx_c);
Ext_D_GDP=exp(Ext_D_GDP);
Ve=exp(Ve);
Dep=exp(Dep);
Dep_c=exp(Dep_c);
Income_c=exp(Income_c);
Income_e=exp(Income_e);



%   spread_e=exp(spread_e);
%   spread_c=exp(spread_c);


Ae=1;
Ac=1;
xie=1;
xic=1;
polsh_e=1;
polsh_c=1;

kappashe=1;
kappashc=1;

gamma_c=exp(gamma_c);
gamma_e=exp(gamma_e);
dummy_lq_Be_1=Be;
dummy_lq_Dep_1=Dep;
dummy_lq_Ic_1=Ic;
dummy_lq_Ie_1=Ie;
dummy_lq_Kc_1=Kc;
dummy_lq_Ke_1=Ke;
dummy_lq_Nc_1=Nc;
dummy_lq_Qc_1=Qc;
dummy_lq_R_c_1=R_c;
dummy_lq_Ve_1=Ve;
dummy_lq_xic_cor_1=xic_cor;
assignin('base','fname_',M_.fname);
%%%%%%%%%%%%%%%%%%
% This part is necessary only in case want to derive the Ramsey policy as the model is in log-deviations and
% should not have log of (possibly negative) Lagrange Multipliers.
% as in the optimal model Lagrange multipliers are not logged
tmp=evalin('base','M_.endo_names');
[aa,bb]=find_incell(str2cell(tmp),'ramsey');
bb2=setdiff([1:size(tmp,1)]',bb);
for jj=1:length(bb2);
    eval([tmp(bb2(jj),:),'=log(',lgy_(bb2(jj),:),');']);
end
%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% END MODEL SPECIFIC PART (but see log-assignment in the last part of the ended block
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ALSO NOTICE that below have to give the extension of steady state values of variables appearing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% in the dynamic model (e.g. y_ss): If don't have it... don't bother...
%%%%%% IMPORTANT definition of vector of variables' names

% lgy_=evalin('base','lgy_');% this still is needed as a place-holder for Ramsey stuff
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Assignment of values to names, to global names and to steady-state
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% parametrization of the variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Notice that in the previous block we assigned log(value) to all the variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% for this reason we don't take logs again. This would be the case also if the model
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% is in level-deviations
% % CREATE OUTPUT AUTOMATICALLY: PROBLEM WITH EXACT ZEROS
M_=evalin('base','M_');
ys=[];
for jj=1:size(M_.endo_names,1)
    try
        ys(jj,1)=(eval(M_.endo_names(jj,:)));
    catch
        sprintf('Problem with variable ==> %s',M_.endo_names(jj,:));
    end
end

M_=evalin('base','M_');
ys=[];
for jj=1:size(M_.endo_names,1)
    try
        ys(jj,1)=(eval(M_.endo_names(jj,:)));
        eval(['global  ',deblank(M_.endo_names(jj,:)),'_ss']);
%         lgy_(kkk,:)
        eval([deblank(M_.endo_names(jj,:)),'_ss=(',M_.endo_names(jj,:),');'])
    catch
        sprintf('Problem with variable ==> %s',M_.endo_names(jj,:));
    end
end
%% assign parameters
for jj=1:size(M_.param_names,1);
    %     [xx]=regexp(M_.param_names(jj,:),'\_ss\>');
    %     if ~isempty(xx)
    try
        M_.params(jj,:)=eval([M_.param_names(jj,:),';']);
    catch
        error(sprintf('Missing value of parameter %s\n:',M_.param_names(jj,:)))
        
    end
    %     end
end
assignin('base','M_',M_);
return
% MANUALLY run the following two lines and copy the command-window output
% below
if 0
    uu=[];for jj=1:size(M_.endo_names,1);uu{jj,1}=['ys(',num2str(jj),',1)=log(',M_.endo_names(jj,:),');'];end;
    char(uu)
end
