% Parameters of GB model
% param_GB_multiple_Nash_equilibria;
if 1
    %%
    global kappa_c kappa_e mu peg ld gamma_B nash_param balbg uu_h ffr cmk nbeta n
    global kappa_MPc kappa_MPe  kappa_MPe_bar  kappa_MPc_bar rams Nash k_D BX_obj kappa_cmk
    global uu_f psi_D
    global tx_alpha_k tx_beta_k tx_gamma_k optim_EME optim_AE
    %% following: 1=estimate model
    estimation_=0;
    warning('off','MATLAB:declareGlobalBeforeUse')
    %% COMMENTING PARTS FOR SIMULATION
    %% following: if 1 then the nash-model generates a cooperative solution; if 0 the same model generates the Nash solution
    % this does not hodl for the coop-model, which generates the coop solution
    % only
    % nash (0) vs coop (1)
    %     nash_param=0;
    
    %% home country weight in utility (to comment out if searching for Pareto
    % weights)
    %   uu_h=1;
    
    %% POLICY RULES
    %   kappa_MPe=0;% both nash and coop and -9.5 -7
    %   kappa_MPc=0;%3 nash,7 coop (balbg=1); and -35 -43
    %% FINANCIAL DEPENDENCY
    %    k_D=0.00; % share of deposits in total funds of country e: D/V=k_D/(1-k_D) ie V=(1-k_D)/k_D*D
    %% TIL HERE COMMENTING
    %% COMPLETE MARKETS (0/1) For incomplete markets there is a problem with Ramsey and open loop nash finding a ss tax
%     cmk=1;
    %   kappa_cmk=0; % This is the parameter to find Arrow-Debreu distributions
    BX_obj=0;
    
    
    %1: Use labor penalty, 0: Use utility penalty
    H_pen = 0;
    
    
    %  psi_D=1/(1-k_D); % ratio of deposits to foreign funds +1, ie if 1 no deposits if >1 deposits
    % Financial frictions (to comment out if experimenting with/o fin fr.
    %  ffr=1;
    if ffr==1
        kappa_e=0.25;
        kappa_c=0.25;
    else
        kappa_e=0.0001;
        kappa_c=0.0001;
    end
    
    
    uu_f=1; % this is not a weight!! don't touch!!!
    
    peg=0; % exchange rate peg
    
    %%%
    ld=0; % liability dollarization
    
    gamma_B=-0.001;% premium on foreign assets (note that this is not on NFA but only households position)
    
    
    
    
    %%
    mu=0;%0.1;
    bgg=0;
    betta=1/(1.03)^(1/4);
    
    %% SIZE
    %n=1/3; % size EM
    
    
    nbeta=betta;
    
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    nash=1;
    aleph=0;% not used
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % thetta=0.98;
    siggma=1; % risk aversion households (check out that preferences are set log in utility; uncomment in mod file
    pssi=3; % 1.3; %inverse of Frish elasticity (NAWM)
    chhi    =   1;            %labor utility weight
    elle=4; % max function for complementary slackness
    alphha=0.35; % share of capital in production
    
    varphi_Lc=0;%8 % adjustment cost of labor
    varphi_Le=0;%8
    
    deltta=0.025; % depreciation of capital
    etta=2;1.728; %3; adjustment cost of capital
    cee = 1; % 1 if CEE adjustment costs and 0 if classic I/K
    scaling=2; % scaling factor for penalty function
    %  Target from DOT statistics is about 4% of US export viz EMEs (average since 2000 of average export share and import share)
    % for EMEs it is actually slightly larger; so put 4% for all
    op=0.3;% trade openness;
    % v_p_c=.9;% size-adjustend home bias
    % v_p_e=.9;
    % op=(1-v_p_c)/n;
    v_p_e=1-op*(1-n); %home bias in consumption corrected for country size
    v_p_c=1-op*n; % size-adjustend home bias
    % v_p_e=.75;
    eta_p=1.5; %x-country elasticity of substitution
    sigmp=6; %domestic elasticity of substitution
    mk_subs=(sigmp-1)/sigmp; % subsidy to monopolistic producers (inverse of markup); =1 if no subsidy
    
    calvo =0;0.85; %calvo probability
    
    % eta0=18;
    % eta1=0;
    % eta2=-.035;
    
%     if cmk==0
%         BX_obj=0;
%     end
    % policy
    lambda_pc=1.2;
    lambda_yc=.2;
    lambda_rc=.85;
    
    global pi_c_obj pi_e_obj
    pi_c_obj=1;
    pi_e_obj=1;
    pstab=1;
    pind=1;
    poly=0; %policy tag for Ramsey
    
    %% MAP
    
    
    %% POLICY RESPONSES
    if 0 % zero if search for optimal
        
        if balbg==1
            if rams
                kappa_MPe=0.50000;% both nash and coop and -9.5 -7
                kappa_MPc=4.00000;%3 nash,7 coop (balbg=1); and -35 -43
            else
                kappa_MPe=1;% both nash and coop and -9.5 -7
                kappa_MPc=2.50000;%3 nash,7 coop (balbg=1); and -35 -43
            end
        elseif balbg==0;
            if rams
                kappa_MPe=-11.0;% both nash and coop and -9.5 -7
                kappa_MPc=-106.0;%3 nash,7 coop (balbg=1); and -35 -43
            else
                kappa_MPe=-5.5;% both nash and coop and -9.5 -7
                kappa_MPc=-106.5;%3 nash,7 coop (balbg=1); and -35 -43
                
            end
        end
    end
    
    %kappa_MPe=0;% both nash and coop and -9.5 -7
    %kappa_MPc=0;%3 nash,7 coop (balbg=1); and -35 -43
    
    %% BALANCED BUDGET PARAMETER
    balbg=1; %=1 for balanced budget; 0= debt dynamics
    rams=1; %for tables of welfare
    %%  %% Taxes
    lumpsum=1; %share of debt adjustment born by lump-sum taxes as opposed to labor taxes
    lumpsum_ss=1;
    %% FISCAL RULE
    kappa_lte=0.15; %fiscal rule on labor tax e
    kappa_ltc=0.15; %fiscal rule on labor tax c
    
    
    
    %% TAX SMOOTHING
    tx_smooth=0; % preference for labor tax smoothness
    % tx_smooth_k=0; %.1; % preference for capital tax smoothness
    pref_tx_k_m1=0; % 0 if preference for deviation from zero, 1 if growth rate of taxes
    pref_tx_l_m1=0; % 0 if preference for deviation from zero, 1 if growth rate of taxes
    %% Costs of MaP intervention
    MaP_cost2=0; % quadratic cost in departing from the steady-state macro-pru
    MaP_cost=00;%This parameter is in the x10K of consumption
    
    
    
    %% MAP
    % Steady state macro pru: Note that cannot "tax" too much: must compensate
    % with higher transfers
    kappa_MPe_bar=1; .99; %  it's the steady state reserve requirement; It's 1-requirement
    kappa_MPc_bar=1; .99; % There are corner solutions if these are not similar
    kappa_MPe_obj=.99;
    kappa_MPc_obj= kappa_MPe_obj;
    
    
    
    %% If subsd=1, costs are not active and the capital tax is adjusted countercyclically; zero [0] activates costs
    subsd=1;
    
    
    %% old stuff
    MP_cost1=0; % linear cost in departing from the steady-state macro-pru [note that on average MaP<ss]
    
    MP_cost_ss=0;
    MP_gdp=0; % if 0 then respond to leverage
    %% subsidy policy
    MaP_subsd_e=1;
    MaP_subsd_c=1;
    %% end old stuff
    global tau_k_e_obj tau_k_c_obj
    
    %
    %  tau_k_e_obj =0;-0.16823487838991468823;
    %  tau_k_c_obj =0;-0.30551591033974112577;
    
    pef_prem_stab=0; %% switch: 1=perfect premium stabilization; 0=standard feedback rule
    
    
    
    
    % shocks
    
    %Heathcote Perri give the following
    %C=[0.0073^2,0.29*(0.0073*0.0044);0.29*(0.0073*0.0044),0.0044^2]
    % then use cholesky plus rotation to have small country not influencing
    % large country
    % cl=chol(C);
    % r=norm(cl(:,2))
    % c=cl(2,2)/r
    % s=-cl(1,2)/r
    % G=[c s ;-s c]
    % Sigma_e_Ae_e_Ac=(cl*G)'
    rho_Ae=0.85;.97;
    rho_Ac=rho_Ae;
    rho_Ae_c=0;0.025;
    rho_Ac_e=rho_Ae_c;
    
    rho_polsh_c=0.0;
    rho_xi=0.85;
    rho_kappashe=0.85;
    rho_kappashc=0.85;
    
    std_Ae=0.007;
    std_Ac=0.007;
    std_Ae_c=0.000;1;
    std_Ac_e=0; %0.007;0.0021;1; %cholesky plus rotation and use transpose result
    std_polsh_c=0.00;
    std_polsh_e=0.00;
    std_xi_c=.003;
    std_xi_e=.003;
    std_kappashe=.002;
    std_kappashc=.002;
    std_mserr=0.000;
    %calibrated (obtained numerically)
    % std_Ae       =0.0076125;
    % std_Ac       =0.0072911;
    % std_xi_e     =0.0030229;
    % std_xi_c     =0.0034992;
    % std_Ac_e     =0.0068544;
    % std_Ae=0.00;
    % std_Ac=0.00;
    % std_polsh_c=0.00;
    % std_polsh_e=0.00;
    % std_xi_c=.00;
    % std_xi_e=.00;
    % std_kappashe=.00;
    % std_kappashc=.00;
    % std_mserr=0.000;
    
    % financial block
    pig=pi;
    
    deltta_T_e=0.01;0.008;%0.006;% 0.002; GK %Transfer to entrepreneus
    deltta_T_c=0.01;0.008;%0.006;% 0.002; GK %Transfer to entrepreneus
    thetta_e=0.9;.94;%0.97; GK%-(spread + 1/betta*omegga + (1/betta^4*kappa^2 - 2*1/betta^3*betta*kappa^2 + 4*1/betta^3*betta*kappa*omegga - 2*1/betta^3*kappa*omegga + 1/betta^2*betta^2*kappa^2 - 2*1/betta^2*betta*kappa*omegga + 4*1/betta^2*betta*kappa*spread - 2*1/betta^2*kappa*spread + 1/betta^2*omegga^2 - 2*1/betta*betta*kappa*spread + 2*1/betta*omegga*spread + spread^2)^(1/2) - 1/betta^2*kappa - 1/betta*betta*kappa)/(2*1/betta^2*betta*kappa);
    thetta_c=thetta_e;
    
    
    % Note that in order to have non binding constrain must have
    if (deltta_T_c-kappa_c*(1-thetta_c/betta/kappa_MPc_bar)>0)%||(deltta_T-kappa_e*(1-thetta/betta/kappa_MPc_bar/kappa_MPe_bar)>0)
        binding=0;
    else
        binding=1;
    end
    
    options_.pruning=0;
    options_.nomoments=0;
    options_.nocorr=1;
    options_.irf=00;
    options_.periods=0;
    options_.replic=0;
    options_.noprint=1;
    options_.nodisplay=1;
    options_.nograph=1;
    options_.graphics.ncols=4;
    options_.graphics.nrows=4;
    options_.aim_solver=0;
    % options_.steadystate.nocheck=0;
    options_.order=2;
    %% RUBBISH TO BE TAKED OUT OF THE MOD
    MaP_e_Intercept=0;
    MaP_e_tau_k_e=0;
    MaP_e_Leverage_e=0;
    MaP_e_tau_k_e_0=1;
    MaP_c_tau_k_c_0=1;
    MaP_e_Ke=0;
    MaP_e_Pe=0;
    MaP_e_Ne=0;
    MaP_e_Ce=0;
    MaP_e_He=0;
    MaP_e_Ie=0;
    MaP_e_spread_e=0;
    MaP_c_Intercept=0;
    MaP_c_tau_k_c=0;
    MaP_c_Leverage_c=0;
    MaP_c_Ve=0;
    MaP_c_Pc=0;
    MaP_c_Nc=0;
    MaP_c_Cc=0;
    MaP_c_Hc=0;
    MaP_c_Ic=0;
    MaP_c_spread_c=0;
    MaP_e_RER=0;
    MaP_c_RER=0;
    
    % uu_h=1;
    % uu_f=1;
    % kappa_cmk=0;
    % k_D=0.00;
    if k_D<1
        psi_D=1/(1-k_D);
        dom_dep100=0;
        %the larger relative to e, the more E would respond
        kappa_Vc=1*kappa_c;
    else
        psi_D=1;
        dom_dep100=1;
        %the larger relative to e, the more E would respond
        kappa_Vc=0;
    end
    % kappa_MPe=0;
    % kappa_MPc=0;
    % doloop=0;
    % ffr=1;
    % param_GB_calibration_found_March_2019;
    % return
end
