%% SEE BanksEMEs_v28_with_GKM.pdf (or variants)
global ffr

pi_e=1;
pi_c=1;
pi_gdp_e=1;
pi_gdp_c=1;
Rc=pi_c/betta;
RRc=1/betta;
Re=pi_e/betta;
if k_D<1
    RRe=((R_b/pi_c-Re/pi_e)+psi_D*Re/pi_e)/psi_D;%% after correction by Steve Wu (thanks!)
else
    RRe=Re/pi_e;
end
R_b_tilde=RRe;
pen=0;
tau_k_e=tau_k_e_obj;
tau_k_c=tau_k_c_obj;
tau_l_e=(1-lumpsum_ss)*(-alphha/(1-alphha)*tau_k_e);
tau_l_c=(1-lumpsum_ss)*(-alphha/(1-alphha)*tau_k_c);

tax_pen_e= tx_alpha_k*tau_k_e_obj^2;
tax_pen_c= tx_alpha_k*tau_k_c_obj^2;


Delta_tau_k_c = 0;
Delta_tau_k_e = 0;


%% USING value function (relative to net worth) of EME banks (page 13 of BanksEMEs_v28_with_GKM)
if binding
    
    a=thetta_e;
    b=(thetta_e*RRe+1)*deltta_T_e-thetta_e*kappa_e*(1-thetta_e*RRe)/betta/(1-thetta_e)*(1-betta);
    c=-deltta_T_e/betta/(1-thetta_e)*(kappa_e*(1-thetta_e*RRe))*(1-betta*thetta_e*RRe)+deltta_T_e^2*RRe;
    
    
    discr=(b^2-4*a*c);
    
    
    Rxe=(-b+sqrt(discr))/(2*a);
    Rke=Rxe+RRe;
    
    
    
    if discr<0 ;
        pen=1;
    end
    
else
    
    alpha_ve=1;
    Rkc=Rc/kappa_MPc_bar;
    
    Rke=Rkc/kappa_MPe_bar;
    Rxe=(Rke-RRe);
    gamma_e=0;
    %      Rke=(1-deltta_T_e)/(thetta_e*(1-Gamma_w)*Rkc+Gamma_w-mu*F2)*Rkc;
end


    RER=1;
    Pc=1;




MC_e=1;

MC_c=1;






Ke=(MC_e*(1-tau_k_e)*alphha/(Rke-(1-deltta)))^(1/(1-alphha))*He;
Ie=deltta*Ke;

Ne=(thetta_e*Rxe+deltta_T_e)/(1-thetta_e*RRe)*Ke;

Nes=(Ne-deltta_T_e*Ke)/thetta_e;
v_e=betta*Nes/Ne*(1-thetta_e)/(1-betta*thetta_e*Nes/Ne);
if k_D<1
Ve=1/psi_D*(Ke-Ne)/RER^ld;
Dep=(psi_D-1)*RER^ld*Ve;
else
    Ve=0;
    Dep=(Ke-Ne);
end


%Ne=thetta_e*Rke*Qe*Ke*xie +deltta_T_e*Qe*Ke - (R_b_tilde*psi_D*(Dep+Ve));



if binding
    if k_D<1
    Rkc=R_b/pi_c ;
    else
            a=thetta_c;
    b=(thetta_c*Rc+1)*deltta_T_c-thetta_c*kappa_c*(1-thetta_c*Rc)/betta/(1-thetta_c)*(1-betta);
    c=-deltta_T_c/betta/(1-thetta_c)*(kappa_c*(1-thetta_c*Rc))*(1-betta*thetta_c*Rc)+deltta_T_c^2*Rc;
    
    
    discr=(b^2-4*a*c);
    
    
    Rxc=(-b+sqrt(discr))/(2*a);
    Rkc=Rxc+Rc;
    R_b=Rc;
    end
else
    % this condition is used as residual condition in this case
end

% PHI=Rkc;


Kc=(MC_c*(1-tau_k_c)*alphha/(Rkc-(1-deltta)))^(1/(1-alphha))*Hc;
WG=Kc+n/(1-n)*Ve/RER^(1-ld);
Nc= (thetta_c*((Rkc-RRc)*Kc+(R_b/pi_c-RRc)*n/(1-n)*Ve/RER^(1-ld))+deltta_T_c*Kc)/(1-thetta_c*RRc);
Ncs=(Nc-deltta_T_c*Kc)/thetta_c;
% v_c=betta*Ncs/Nc*(1-thetta_c)/(1-betta*thetta_c*Ncs/Nc);
Ic=deltta*Kc;





%Added the labor penalty here
Cc=(MC_c*(1-tau_l_c)*(1-alphha)*(Kc/Hc)^alphha/(chhi*(Hc+H_pen*tax_pen_c)^pssi))^(1/siggma);
Ce=(MC_e*(1-tau_l_e)*(1-alphha)*(Ke/He)^alphha/(chhi*(He+H_pen*tax_pen_e)^pssi))^(1/siggma);



% Ye=v_p_e*(Pe)^(-eta_p)*(Ce+Ie+mu*F2*Rke*(Ke))+(1-n)/n*(1-v_p_c)*(Pe/RER)^(-eta_p)*(Cc+Ic);
% Yc=n/(1-n)*(1-v_p_e)*(Pc*RER)^(-eta_p)*(Ce+Ie+mu*F2*Rke*(Ke))+(v_p_c)*(Pc)^(-eta_p)*(Cc+Ic);

%Ye=v_p_e*(Pe)^(-eta_p)*(Ce+Ie)+(1-n)/n*(1-v_p_c)*(Pe/RER)^(-eta_p)*(Cc+Ic);

Ye=Ke^(alphha)*He^(1-alphha);

%Yc=n/(1-n)*(1-v_p_e)*(Pc*RER)^(-eta_p)*(Ce+Ie)+(v_p_c)*(Pc)^(-eta_p)*(Cc+Ic);

Yc=-Ye*n/(1-n)+n/(1-n)*(Ce+Ie)+(Cc+Ic);


YeNet=Ye;







% alpha_ve=betta*(1-thetta_c)*(1-Gamma_w)*Rke/(thetta_c*(1-betta)*(1-Gamma_w)*Rke+deltta_T_c);
V_e=betta*(1-thetta_e)*Nes/Ne/(1-thetta_e*betta*Nes/Ne);
if binding % this is not necessary once impose equality with V_e
    
%     a=betta*thetta_e/kappa_e*(Rke-RRe);
%     b=betta*(1-thetta_e)*(Rke-RRe)/kappa_e+thetta_e*betta*RRe-1;
%     c=betta*(1-thetta_e)*RRe;
%     
%     discr=(b^2-4*a*c);
%     if discr<0;
%         pen=1+abs(discr);
%     end
%     alpha_ve=(-b-sqrt(b^2-4*a*c))/(2*a);
%     if abs(alpha_ve-V_e)>1e-8;
% %         disp('Positive e')
%         alpha_ve=(-b+sqrt(b^2-4*a*c))/(2*a); % for some cases the plus is what makes it match V_c
%     end
   alpha_ve=V_e;
    
    gamma_e=1-betta*RRe*((1-thetta_e)+thetta_e*alpha_ve)/alpha_ve;
    if gamma_e<0
        pen=1+abs(discr);
    end
else
    %     gamma_e=0;
    %     alpha_ve=(1-thetta_e)*Gamma_wp/((1-thetta_e)*Gamma_wp-mu*F2p);
    % already computed
end


V_c=betta*(1-thetta_c)*Ncs/Nc/(1-thetta_c*betta*Ncs/Nc);

if binding % this is not necessary once impose equality with V_e
%     a=betta/kappa_c*thetta_c*(Rkc-RRc);
%     b=betta/kappa_c*(1-thetta_c)*(Rkc-RRc)-(1-betta*RRc*thetta_c);
%     c=betta*RRc*(1-thetta_c);
%     
%     
%     
%     discr=(b^2-4*a*c);
%     if discr<0
%         pen=1+abs(discr);
%     end
%     
%     alpha_vc=(-b-sqrt(b^2-4*a*c))/(2*a); % for some cases the plus is what makes it match V_c
% 
%     if abs(alpha_vc-V_c)>1e-8;
% %         disp('Positive c')
%         alpha_vc=(-b+sqrt(b^2-4*a*c))/(2*a); % for some cases the plus is what makes it match V_c
%     end
alpha_vc=V_c;
    gamma_c=betta/kappa_c*(Rkc-RRc)*((1-thetta_c)+thetta_c*alpha_vc);
    if gamma_c<-1e-9
        pen=1+abs(gamma_c);
    end

else
    alpha_vc=1;
    gamma_c=0;
end








T=(1-thetta_e)*Nes-deltta_T_e*Ke;% including transfers
Tc=(1-thetta_c)*Ncs-deltta_T_c*Kc;

We=MC_e*(1-alphha)*(Ke/He)^alphha;

Be=RER^(ld-1)*Ve;
% Vf_e=betta*(1-thetta_e)*Nes/Ne/(1-thetta_e*betta*Nes/Ne);
% Vf_c=betta*(1-thetta_c)*Ncs/Nc/(1-thetta_c*betta*Ncs/Nc);




Tx_e=-lumpsum*tau_k_e*Ye*alphha+MaP_cost*(tau_k_e+MaP_cost2*tau_k_e^2);
Tx_c=-lumpsum*tau_k_c*Yc*alphha+MaP_cost*(tau_k_c+MaP_cost2*tau_k_c^2);

%tax_pen_e=tx_smooth*(tau_l_e-pref_tx_l_m1*tau_l_e)^2 ...
%+tx_smooth_k*(tau_k_e-pref_tx_k_m1*tau_k_e)^2;
%tax_pen_c=tx_smooth*(tau_l_c-pref_tx_l_m1*tau_l_c)^2 ...
%+tx_smooth_k*(tau_k_c-pref_tx_k_m1*tau_k_c)^2;




Dep_c=Kc+n/(1-n)*Ve-Nc;


if ffr==0
    Dep=0;
    Dep_c=0;
end





