
%find steady state reserves
% clear all
global tx_alpha_k tx_beta_k tx_gamma_k
global  kappa_MPe_bar  kappa_MPc_bar ffsolver pi_c_obj pi_e_obj tau_k_e_obj tau_k_c_obj nash_param uu_h optim_EME optim_AE Policy_Regime n
% rng1=[-.99:0.001:-.94];
% err=[];
% for jj=1:length(rng1)
%     kappa_MPe_bar=rng1(jj);
%     kappa_MPc_bar=rng1(jj);
%     [xx,xxx,tmp]=GB_Alloptimal_steadystate;
%     err(jj,1)=norm(tmp,10);
%     err(jj,2)=kappa_MPe_bar;
% end
% figure; plot(err(:,2),err(:,1))
% 0.9855
% current optimal x2           0.97423

global ffr BX_obj tx_smooth_k kappa_MPc kappa_MPe kappa_e kappa_c  cmk rams Nash verbose
global kappa_cmk uu_f psi_D k_D doloop


% gglob=evalin('base','who(''global'');');
% results=[];
% uu_h=1;
% uu_f=1;
% nash_param=1;
% kappa_cmk=0;
% tau_k_e_obj =0;
% tau_k_c_obj =0;
% k_D=0.00;
% psi_D=1/(1-k_D);
% kappa_MPe=0;
% kappa_MPc=0;
% doloop=0;
% IT=0;
% taylor=1;
% ash=0;
% scenarios_=5;


% try
%     if nash_param==1 % now using the same code for all
%         %         uu_h=coop_weight;
%         xx=find_incell(M_.fname,'optimal');
%         if isempty(xx)
%             dynare GB_subsidy_optimal_SDLT noclearall
%         else
%             eval(['dynare ',M_.fname,' noclearall'])
%         end
%
%
%     else
%         %         uu_h=1;
%                 xx=find_incell(M_.fname,'optimal');
%         if isempty(xx)
%             dynare GB_subsidy_optimal_SDLT noclearall
%         else
%             eval(['dynare ',M_.fname,' noclearall'])
%         end
%     end
% catch errd
% end
warning('off')

if ~exist('starting_value','var');
        %tau_k_e_obj =   0;%   -0.4411;
   
        %tau_k_c_obj =   0; %-0.2715;
        %starting_value=[        tau_k_e_obj
        %    tau_k_c_obj];
        
        
     switch Policy_Regime
        case 1 %Both countries
             starting_value=[tau_k_e_obj tau_k_c_obj];
        case 2 %EME only
            starting_value=tau_k_e_obj;
        case 3 %AE only
            starting_value=tau_k_c_obj;
     end
    
        fval=1000;
    
else
   [fval]=wrapper_steady_state_alloptimal(starting_value);
end
if 1;norm(fval)>1e-8
    filename='wrapper_steady_state_alloptimal';
    
    
    algo=2;
    
    
    if algo==1
        ffsolver=0;
        starting_value=starting_value(:);
        %simulating annealing
        LB=-ones(size(starting_value));
        UB=ones(size(starting_value));
        
        neps=4;
        %  Set input parameters.
        maxy=0;
        eps=1.0e-5;
        rt_=.5;
        t=5.0;
        ns=4;
        nt=6;
        maxevl=1000;
        idisp =1;
        npar=length(starting_value);
        
        disp(['size of param',num2str(length(starting_value))])
        c=1*ones(npar,1);
        %*  Set input values of the input/output parameters.*
        
        vm=.1*ones(npar,1);
        disp(['number of parameters= ' num2str(npar) 'max= '  num2str(maxy) 't=  ' num2str(t)]);
        disp(['rt_=  '  num2str(rt_) 'eps=  '  num2str(eps) 'ns=  '  num2str(ns)]);
        disp(['nt=  '  num2str(nt) 'neps= '   num2str(neps) 'maxevl=  '  num2str(maxevl)]);
        %      disp(['iprint=   '   num2str(iprint) 'seed=   '   num2str(seed)]);
        disp '  ';
        disp '  ';
        disp(['starting values(x)  ' num2str(starting_value')]);
        disp(['initial step length(vm)  '  num2str(vm')]);
        disp(['lower bound(lb)', 'initial conditions', 'upper bound(ub)' ]);
        disp([LB starting_value UB]);
        disp(['c vector   ' num2str(c')]);
        
        
        [x, fval, nacc, nfcnev, nobds, ier, t, vm] = sa(filename,starting_value,maxy,rt_,eps,ns,nt ...
            ,neps,maxevl,LB,UB,c,idisp ,t,vm,M_,ffsolver);
        ffsolver=1;
        % set up variables for broyden
        % set up variables for broyden
        starting_value=x;
        nvar    = length(starting_value);                 % number of variables
        xin  = starting_value;                % initial value
        xlo  = -ones(nvar,1)*1;      % lower bounds, may be scalar or vector
        xup  = ones(nvar,1)*.8;               % upper bounds, scalar or vector
        opts = [ 1e-12 1000 1 -1 0];  % eps, maxit, trace, iprint, #constants
        global M_
        [starting_value,flagsb] = Broyden(filename,nvar,xin,xlo,xup,opts);
        starting_value=starting_value(:,end);
        x=starting_value;
        [fval]=wrapper_steady_state_alloptimal(starting_value);
    elseif algo==2
        ffsolver=1;
        options=optimset('MaxFunEvals ',5000, 'Display','on','TolX',1e-16,'TolF',1e-14);
        
        [x,fval]=fsolve(filename,starting_value,options,M_,ffsolver);
        
        if max(abs(fval))>1e-5
            clc       
        end
        
    else
        
        ffsolver=1;
        % set up variables for broyden
        % set up variables for broyden
        nvar    = length(starting_value);                 % number of variables
        xin  = starting_value;                % initial value
        xlo  = -ones(nvar,1)*1.5;      % lower bounds, may be scalar or vector
        xup  = ones(nvar,1)*.99;               % upper bounds, scalar or vector
        opts = [ 1e-12 1000 1 -1 0];  % eps, maxit, trace, iprint, #constants
        global M_
        [starting_value,flagsb] = Broyden(filename,nvar,xin,xlo,xup,opts);
        starting_value=starting_value(:,end);
        x=starting_value;
        [fval]=wrapper_steady_state_alloptimal(starting_value);
    end
    
    %
    % fprintf('tau_k_e_obj =%2.20f;\n',x(1,1));
    % fprintf('tau_k_c_obj =%2.20f;\n',x(2,1));
    
    
    switch Policy_Regime
        case 1 %Both countries
            tau_k_e_obj=x(1);
            tau_k_c_obj=x(2);
             starting_value=[tau_k_e_obj tau_k_c_obj];
        case 2 %EME only
            tau_k_e_obj=x;
            starting_value=tau_k_e_obj;
        case 3 %AE only
            tau_k_c_obj=x;
            starting_value=tau_k_c_obj;
    end


    
end %if residual is large



%%
return
nash_param=0;
rs=[];
rng1=[-.5:.05:.35];
for cnt1=1:length(rng1)
    for cnt2=1:length(rng1)
        
        rs(cnt1,cnt2)=norm(wrapper_steady_state_alloptimal([rng1(cnt1),rng1(cnt2)]));
    end
end
figure;
surfc(rng1,rng1,rs)