%wrapper for steady-state

function [tmp2]=wrapper_steady_state_alloptimal(x,M_,ffsolver_in)
global ffsolver
global  kappa_MPe_bar  kappa_MPc_bar  pi_c_obj pi_e_obj tau_k_e_obj tau_k_c_obj M_ ffsolver_in
global tx_alpha_k tx_beta_k tx_gamma_k Policy_Regime
if nargin>1
    assignin('base','M_',M_)
    
end;
%     
% if nargin==3
% ffsolver=ffsolver_in;
% end
% x
%     pi_e_obj=x(1,1);
%     pi_c_obj=x(2,1);

switch Policy_Regime
    case 1 %Both countries
        tau_k_e_obj=x(1);
        tau_k_c_obj=x(2);
    case 2 %EME only
        tau_k_e_obj=x;
    case 3 %AE only
        tau_k_c_obj=x;
end
   
[xx,xxx,tmp]=evalin('base',[M_.fname,'_steadystate']);

%Tim addition which uses the static model to solve rather than the
%steadystate file
if 0
    ys=xx;
    assignin('base','ys', ys);
    [tmp, ~, ~, ~]=evalin('base',[M_.fname,'_static(ys,zeros(M_.exo_nbr,1),M_.params)']);
end

    
    
if ffsolver==0
    tmp2=(norm(tmp,inf));%-log(min(betapdf(x/1.5,5.75,5.75)));
else
    nn=floor(length(tmp)/2);
    tmp2(1,1)=(norm(tmp(1:nn),inf));%/min(betapdf(x/2,5.75,5.75)));
    tmp2(2,1)=(norm(tmp(nn+1:end),inf));%/min(betapdf(x/2,5.75,5.75)));
end

end